diff --git a/bsp/ar71xx/.config b/bsp/ar71xx/.config
index 6c2c730d..94014467 100644
--- a/bsp/ar71xx/.config
+++ b/bsp/ar71xx/.config
@@ -4,82 +4,22 @@
 CONFIG_TARGET_ar71xx=y
 CONFIG_TARGET_ar71xx_tiny=y
 CONFIG_TARGET_MULTI_PROFILE=y
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_archer-c25-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_archer-c25-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_archer-c60-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_archer-c60-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_archer-c60-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_archer-c60-v2=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_archer-c7-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_archer-c7-v2=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_archer-c7-v5=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_archer-c7-v5=""
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_cpe210-220-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_cpe210-220-v1="-rssileds"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_cpe210-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_cpe210-v2="-rssileds"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_cpe210-v3=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_cpe210-v3="-rssileds"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_cpe510-520-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_cpe510-520-v1="-rssileds"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_gl-ar150=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_gl-ar150=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-mr3020-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-mr3020-v1="-uboot-envtools -kmod-usb-core -kmod-usb2 -kmod-usb-ledtrig-usbport"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wa850re-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wa850re-v1="-uboot-envtools -rssileds"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wa860re-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wa860re-v1="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wa901nd-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wa901nd-v2="-uboot-envtools"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wdr3500-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wdr3500-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wdr3600-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wdr3600-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wdr4300-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wdr4300-v1=""
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wdr4310-v1=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wdr4310-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr1043nd-v1=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr1043nd-v1=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr1043nd-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr1043nd-v2=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr1043nd-v3=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr1043nd-v3=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr1043nd-v4=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr1043nd-v4=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr1043n-v5=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr1043n-v5=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr740n-v4=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr740n-v4="-uboot-envtools"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr741nd-v2=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr741nd-v2="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr741nd-v4=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr741nd-v4="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v7=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v7="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v8=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v8="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v9=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v9="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v10=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v10="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v11=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v11="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr841-v12=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr841-v12="-uboot-envtools"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_tl-wr842n-v2=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_tl-wr842n-v2=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_ubnt-bullet-m=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_ubnt-bullet-m="-rssileds"
 CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_ubnt-loco-m-xw=y
 CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_ubnt-loco-m-xw="-rssileds"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_ubnt-nano-m=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_ubnt-nano-m="-rssileds"
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_ubnt-unifi=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_ubnt-unifi=""
-CONFIG_TARGET_DEVICE_ar71xx_tiny_DEVICE_ubnt-unifiac-lite=y
-CONFIG_TARGET_DEVICE_PACKAGES_ar71xx_tiny_DEVICE_ubnt-unifiac-lite=""
 CONFIG_BUSYBOX_CUSTOM=y
 CONFIG_TARGET_PER_DEVICE_ROOTFS=y
 # CONFIG_BUSYBOX_CONFIG_BRCTL is not set
diff --git a/bsp/ath79-tiny/.config b/bsp/ath79-tiny/.config
new file mode 100644
index 00000000..4e249e3b
--- /dev/null
+++ b/bsp/ath79-tiny/.config
@@ -0,0 +1,49 @@
+# Generated using "./buildscript config openwrt".
+# Do no edit manually
+#
+CONFIG_TARGET_ath79=y
+CONFIG_TARGET_ath79_tiny=y
+CONFIG_TARGET_MULTI_PROFILE=y
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-mr3020-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-mr3020-v1="-uboot-envtools -kmod-usb-core -kmod-usb-chipidea2 -kmod-usb-ledtrig-usbport"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wa901nd-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wa901nd-v2="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr740n-v4=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr740n-v4="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr741nd-v4=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr741nd-v4="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v7=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v7="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v8=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v8="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v9=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v9="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v10=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v10="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v11=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v11="-uboot-envtools"
+CONFIG_TARGET_DEVICE_ath79_tiny_DEVICE_tplink_tl-wr841-v12=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_tiny_DEVICE_tplink_tl-wr841-v12="-uboot-envtools"
+CONFIG_BUSYBOX_CUSTOM=y
+CONFIG_TARGET_PER_DEVICE_ROOTFS=y
+# CONFIG_BUSYBOX_CONFIG_BRCTL is not set
+# CONFIG_BUSYBOX_CONFIG_CROND is not set
+# CONFIG_BUSYBOX_CONFIG_CRONTAB is not set
+# CONFIG_BUSYBOX_CONFIG_FEATURE_FAST_TOP is not set
+# CONFIG_BUSYBOX_CONFIG_FEATURE_NTPD_SERVER is not set
+CONFIG_CLEAN_IPKG=y
+# CONFIG_DROPBEAR_CURVE25519 is not set
+# CONFIG_FASTD_ENABLE_CIPHER_SALSA2012 is not set
+# CONFIG_FASTD_ENABLE_MAC_GHASH is not set
+# CONFIG_FASTD_ENABLE_MAC_UHASH is not set
+# CONFIG_FASTD_ENABLE_METHOD_COMPOSED_GMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_COMPOSED_UMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_GENERIC_GMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_GENERIC_UMAC is not set
+# CONFIG_PACKAGE_ALFRED_VIS is not set
+CONFIG_PACKAGE_hostapd-mini=y
+CONFIG_PACKAGE_iwinfo=m
+CONFIG_PACKAGE_libiwinfo=m
+CONFIG_PACKAGE_opkg=m
+CONFIG_PACKAGE_wpad-mini=m
+CONFIG_STRIP_KERNEL_EXPORTS=y
diff --git a/bsp/ath79/.config b/bsp/ath79/.config
new file mode 100644
index 00000000..1f9e6b6a
--- /dev/null
+++ b/bsp/ath79/.config
@@ -0,0 +1,73 @@
+# Generated using "./buildscript config openwrt".
+# Do no edit manually
+#
+CONFIG_TARGET_ath79=y
+CONFIG_TARGET_ath79_generic=y
+CONFIG_TARGET_MULTI_PROFILE=y
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_glinet_gl-ar150=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_glinet_gl-ar150=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_archer-c25-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_archer-c25-v1=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_archer-c60-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_archer-c60-v1=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_archer-c60-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_archer-c60-v2=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_archer-c7-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_archer-c7-v2=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_archer-c7-v5=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_archer-c7-v5=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_cpe210-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_cpe210-v2="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_cpe210-v3=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_cpe210-v3="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wdr3600-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wdr3600-v1=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wdr4300-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wdr4300-v1=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr1043nd-v1=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr1043nd-v1=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr1043nd-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr1043nd-v2=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr1043nd-v3=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr1043nd-v3=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr1043nd-v4=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr1043nd-v4=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr1043n-v5=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr1043n-v5=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_tplink_tl-wr842n-v2=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_tplink_tl-wr842n-v2=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_bullet-m=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_bullet-m="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_nanostation-loco-m=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_nanostation-loco-m="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_nanostation-m=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_nanostation-m="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_picostation-m=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_picostation-m="-rssileds"
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_unifi=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_unifi=""
+CONFIG_TARGET_DEVICE_ath79_generic_DEVICE_ubnt_unifiac-mesh=y
+CONFIG_TARGET_DEVICE_PACKAGES_ath79_generic_DEVICE_ubnt_unifiac-mesh=""
+CONFIG_BUSYBOX_CUSTOM=y
+CONFIG_TARGET_PER_DEVICE_ROOTFS=y
+# CONFIG_BUSYBOX_CONFIG_BRCTL is not set
+# CONFIG_BUSYBOX_CONFIG_CROND is not set
+# CONFIG_BUSYBOX_CONFIG_CRONTAB is not set
+# CONFIG_BUSYBOX_CONFIG_FEATURE_FAST_TOP is not set
+# CONFIG_BUSYBOX_CONFIG_FEATURE_NTPD_SERVER is not set
+CONFIG_CLEAN_IPKG=y
+# CONFIG_DROPBEAR_CURVE25519 is not set
+# CONFIG_FASTD_ENABLE_CIPHER_SALSA2012 is not set
+# CONFIG_FASTD_ENABLE_MAC_GHASH is not set
+# CONFIG_FASTD_ENABLE_MAC_UHASH is not set
+# CONFIG_FASTD_ENABLE_METHOD_COMPOSED_GMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_COMPOSED_UMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_GENERIC_GMAC is not set
+# CONFIG_FASTD_ENABLE_METHOD_GENERIC_UMAC is not set
+# CONFIG_PACKAGE_ALFRED_VIS is not set
+CONFIG_PACKAGE_hostapd-mini=y
+CONFIG_PACKAGE_iwinfo=m
+CONFIG_PACKAGE_libiwinfo=m
+CONFIG_PACKAGE_opkg=m
+CONFIG_PACKAGE_wpad-mini=m
+CONFIG_STRIP_KERNEL_EXPORTS=y
diff --git a/bsp/board_ar71xx.bsp b/bsp/board_ar71xx.bsp
index 46c5df2f..d3b3983b 100644
--- a/bsp/board_ar71xx.bsp
+++ b/bsp/board_ar71xx.bsp
@@ -1,42 +1,12 @@
 machine=ar71xx
 chipset=ar71xx
 subtarget=tiny
-images=("openwrt-${chipset}-${subtarget}-archer-c25-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-archer-c60-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-archer-c60-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-archer-c7-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-archer-c7-v5-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-cpe210-220-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-cpe210-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-cpe210-v3-squashfs-sysupgrade.bin"
+images=("openwrt-${chipset}-${subtarget}-cpe210-220-v1-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-cpe510-520-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-gl-ar150-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-mr3020-v1-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-tl-wa850re-v1-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-tl-wa860re-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wa901nd-v2-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-tl-wdr3500-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wdr3600-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wdr4300-v1-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-tl-wdr4310-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr1043nd-v1-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr1043nd-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr1043nd-v3-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr1043nd-v4-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr1043n-v5-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr740n-v4-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-tl-wr741nd-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr741nd-v4-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v7-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v8-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v9-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v10-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v11-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr841-v12-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-tl-wr842n-v2-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-ubnt-bullet-m-squashfs-sysupgrade.bin"
         "openwrt-${chipset}-${subtarget}-ubnt-loco-m-xw-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-ubnt-nano-m-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-ubnt-unifi-squashfs-sysupgrade.bin"
-        "openwrt-${chipset}-${subtarget}-ubnt-unifiac-lite-squashfs-sysupgrade.bin"
         )
diff --git a/bsp/board_ath79-tiny.bsp b/bsp/board_ath79-tiny.bsp
new file mode 100644
index 00000000..df10fbc9
--- /dev/null
+++ b/bsp/board_ath79-tiny.bsp
@@ -0,0 +1,14 @@
+machine=ath79
+chipset=ath79
+subtarget=tiny
+images=("openwrt-${chipset}-${subtarget}-tplink_tl-mr3020-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wa901nd-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr740n-v4-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr741nd-v4-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v7-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v8-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v9-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v10-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v11-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr841-v12-squashfs-sysupgrade.bin"
+        )
diff --git a/bsp/board_ath79.bsp b/bsp/board_ath79.bsp
new file mode 100644
index 00000000..7ad22783
--- /dev/null
+++ b/bsp/board_ath79.bsp
@@ -0,0 +1,26 @@
+machine=ath79
+chipset=ath79
+subtarget=generic
+images=("openwrt-${chipset}-${subtarget}-glinet_gl-ar150-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_archer-c25-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_archer-c60-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_archer-c60-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_archer-c7-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_archer-c7-v5-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_cpe210-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_cpe210-v3-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wdr3600-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wdr4300-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr1043nd-v1-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr1043nd-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr1043nd-v3-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr1043nd-v4-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr1043n-v5-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-tplink_tl-wr842n-v2-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_bullet-m-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_nanostation-loco-m-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_nanostation-m-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_picostation-m-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_unifi-squashfs-sysupgrade.bin"
+        "openwrt-${chipset}-${subtarget}-ubnt_unifiac-mesh-squashfs-sysupgrade.bin"
+        )
diff --git a/build_patches/openwrt/0021-ar71xx-fix-swapped-LAN-WAN-MAC-address-for-Archer-C6.patch b/build_patches/openwrt/0021-ar71xx-fix-swapped-LAN-WAN-MAC-address-for-Archer-C6.patch
deleted file mode 100644
index dd013d3b..00000000
--- a/build_patches/openwrt/0021-ar71xx-fix-swapped-LAN-WAN-MAC-address-for-Archer-C6.patch
+++ /dev/null
@@ -1,61 +0,0 @@
-From: Adrian Schmutzler <freifunk@adrianschmutzler.de>
-Date: Wed, 11 Mar 2020 15:46:00 +0100
-Subject: ar71xx: fix swapped LAN/WAN MAC address for Archer C60 v1/v2
-
-The MAC addresses for lan/wan are swapped compared to the vendor
-firmware. This adjusts to vendor configuration, which is:
-
-lan   *:7b   label
-wan   *:7c   label+1
-2.4g  *:7b   label
-5g    *:7a   label-1
-
-Only one address is stored in <&mac 0x8>, corresponding to the label.
-
-This has been checked on revisions v1, v2 and v3.
-
-Since ar71xx calculates the ath10k MAC address based on the ethernet
-addresses, the number there is adjusted, too.
-
-Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
-(cherry picked from commit 14eb54938b525d4c2d2847a6fad7670ed944650c)
-
-diff --git a/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
-index 718fd7555c73c247cb662c0a8638895e2da38b84..8fb5be643c9c1372195bf10e3e45927c2f6a2a55 100644
---- a/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
-+++ b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
-@@ -182,7 +182,7 @@ case "$FIRMWARE" in
- 		ath10kcal_extract "art" 20480 12064
- 		ln -sf /lib/firmware/ath10k/pre-cal-pci-0000\:00\:00.0.bin \
- 			/lib/firmware/ath10k/QCA9888/hw2.0/board.bin
--		ath10kcal_patch_mac $(macaddr_add $(cat /sys/class/net/eth0/address) -1)
-+		ath10kcal_patch_mac $(macaddr_add $(cat /sys/class/net/eth1/address) -1)
- 		;;
- 	cf-e385ac)
- 		ath10kcal_extract "art" 20480 12064
-diff --git a/target/linux/ar71xx/files/arch/mips/ath79/mach-archer-c60-v1.c b/target/linux/ar71xx/files/arch/mips/ath79/mach-archer-c60-v1.c
-index 88f4f081a34db9b289d393d9c7ad4693ddb9b01d..a0839e6bcadd39b826d657141c5ba94fc5b2a729 100644
---- a/target/linux/ar71xx/files/arch/mips/ath79/mach-archer-c60-v1.c
-+++ b/target/linux/ar71xx/files/arch/mips/ath79/mach-archer-c60-v1.c
-@@ -157,8 +157,8 @@ static void __init archer_c60_v1_setup(void)
- 	ath79_register_mdio(0, 0x0);
- 	ath79_register_mdio(1, 0x0);
- 
--	ath79_init_mac(ath79_eth0_data.mac_addr, mac, 0);
--	ath79_init_mac(ath79_eth1_data.mac_addr, mac, 1);
-+	ath79_init_mac(ath79_eth1_data.mac_addr, mac, 0);
-+	ath79_init_mac(ath79_eth0_data.mac_addr, mac, 1);
- 
- 	/* WAN port */
- 	ath79_eth0_data.phy_if_mode = PHY_INTERFACE_MODE_MII;
-@@ -199,8 +199,8 @@ static void __init archer_c60_v2_setup(void)
- 	ath79_register_mdio(0, 0x0);
- 	ath79_register_mdio(1, 0x0);
- 
--	ath79_init_mac(ath79_eth0_data.mac_addr, mac, 0);
--	ath79_init_mac(ath79_eth1_data.mac_addr, mac, 1);
-+	ath79_init_mac(ath79_eth1_data.mac_addr, mac, 0);
-+	ath79_init_mac(ath79_eth0_data.mac_addr, mac, 1);
- 
- 	/* WAN port */
- 	ath79_eth0_data.phy_if_mode = PHY_INTERFACE_MODE_MII;
diff --git a/build_patches/openwrt/0022-ar71xx-remove-wrong-MAC-address-adjustment-for-Arche.patch b/build_patches/openwrt/0022-ar71xx-remove-wrong-MAC-address-adjustment-for-Arche.patch
deleted file mode 100644
index a9b10b10..00000000
--- a/build_patches/openwrt/0022-ar71xx-remove-wrong-MAC-address-adjustment-for-Arche.patch
+++ /dev/null
@@ -1,28 +0,0 @@
-From: Adrian Schmutzler <freifunk@adrianschmutzler.de>
-Date: Wed, 11 Mar 2020 15:52:41 +0100
-Subject: ar71xx: remove wrong MAC address adjustment for Archer C60 v2
-
-The adjustment of the MAC address for Archer C60 v2 in 10_fix_wifi_mac
-is broken since a "mac" partition is not set up for this device on
-ar71xx. Instead, the MAC address is already patched correctly in
-11-ath10k-caldata.
-
-Remove the useless adjustment.
-
-Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
-(cherry picked from commit cbdc91902466dd113b9680566abb2eb2f8022dd4)
-
-diff --git a/target/linux/ar71xx/base-files/etc/hotplug.d/ieee80211/10_fix_wifi_mac b/target/linux/ar71xx/base-files/etc/hotplug.d/ieee80211/10_fix_wifi_mac
-index b58cf9b591f47c394c4c4b4a21e114e16af2da21..d6fac80bc942bc2ddc7d08c1ab0c5ead160701c6 100644
---- a/target/linux/ar71xx/base-files/etc/hotplug.d/ieee80211/10_fix_wifi_mac
-+++ b/target/linux/ar71xx/base-files/etc/hotplug.d/ieee80211/10_fix_wifi_mac
-@@ -15,8 +15,7 @@ case "$board" in
- 	archer-c58-v1|\
- 	archer-c59-v1|\
- 	archer-c59-v2|\
--	archer-c60-v1|\
--	archer-c60-v2)
-+	archer-c60-v1)
- 		echo $(macaddr_add $(mtd_get_mac_binary mac 8)  $(($PHYNBR - 1)) ) > /sys${DEVPATH}/macaddress
- 		;;
- 	*)
diff --git a/build_patches/openwrt/0023-ath79-fix-swapped-LAN-WAN-MAC-address-for-Archer-C60.patch b/build_patches/openwrt/0023-ath79-fix-swapped-LAN-WAN-MAC-address-for-Archer-C60.patch
new file mode 100644
index 00000000..a73a7955
--- /dev/null
+++ b/build_patches/openwrt/0023-ath79-fix-swapped-LAN-WAN-MAC-address-for-Archer-C60.patch
@@ -0,0 +1,38 @@
+From: Adrian Schmutzler <freifunk@adrianschmutzler.de>
+Date: Wed, 11 Mar 2020 15:37:34 +0100
+Subject: ath79: fix swapped LAN/WAN MAC address for Archer C60 v1/v2
+
+The MAC addresses for lan/wan are swapped compared to the vendor
+firmware. This adjusts to vendor configuration, which is:
+
+lan   *:7b   label
+wan   *:7c   label+1
+2.4g  *:7b   label
+5g    *:7a   label-1
+
+Only one address is stored in <&mac 0x8>, corresponding to the label.
+
+This has been checked on revisions v1, v2 and v3.
+
+Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
+(cherry picked from commit 88aead0a665dd349af4fb8afcfe1a16cf90515ae)
+
+diff --git a/target/linux/ath79/dts/qca9561_tplink_archer-c6x.dtsi b/target/linux/ath79/dts/qca9561_tplink_archer-c6x.dtsi
+index deee64a6a7547f1f8cdd40e24210a4af3d7840e0..23ef0cdcbf4ecd6fed0165edf3cdcb11fdcb03f0 100644
+--- a/target/linux/ath79/dts/qca9561_tplink_archer-c6x.dtsi
++++ b/target/linux/ath79/dts/qca9561_tplink_archer-c6x.dtsi
+@@ -91,13 +91,13 @@
+ 	phy-handle = <&swphy4>;
+ 
+ 	mtd-mac-address = <&mac 0x8>;
++	mtd-mac-address-increment = <1>;
+ };
+ 
+ &eth1 {
+ 	status = "okay";
+ 
+ 	mtd-mac-address = <&mac 0x8>;
+-	mtd-mac-address-increment = <1>;
+ };
+ 
+ &wmac {
diff --git a/src/packages/fff/fff-boardname/Makefile b/src/packages/fff/fff-boardname/Makefile
index 9c2f76d9..01fcc0ae 100644
--- a/src/packages/fff/fff-boardname/Makefile
+++ b/src/packages/fff/fff-boardname/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=fff-boardname
-PKG_RELEASE:=6
+PKG_RELEASE:=7
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)
 
diff --git a/src/packages/fff/fff-boardname/files/etc/uci-defaults/15-fff-boardname b/src/packages/fff/fff-boardname/files/etc/uci-defaults/15-fff-boardname
index ee9c3d39..99b6bc7b 100644
--- a/src/packages/fff/fff-boardname/files/etc/uci-defaults/15-fff-boardname
+++ b/src/packages/fff/fff-boardname/files/etc/uci-defaults/15-fff-boardname
@@ -3,50 +3,13 @@
 BOARD=$(cat /var/sysinfo/board_name)
 
 case "$BOARD" in
-    tl-wr1043nd)
-        BOARD=tl-wr1043nd-v1
-        ;;
-    tl-wr1043nd-v2)
-        grep "v3" /var/sysinfo/model && BOARD=tl-wr1043nd-v3
-        ;;
     tl-wr741nd)
         grep "Atheros AR7240 rev 2" /proc/cpuinfo && BOARD=tl-wr741nd-v2 || BOARD=tl-wr741nd-v4
         ;;
-    tl-wr741nd-v4)
-        grep 740 /var/sysinfo/model && BOARD=tl-wr740n-v4
-        ;;
-    tl-wr841n-v7)
-        BOARD=tl-wr841-v7
-        ;;
-    tl-wr841n-v8)
-        BOARD=tl-wr841-v8
-        ;;
-    tl-wr841n-v9)
-        BOARD=tl-wr841-v9
-        grep "v10" /var/sysinfo/model && BOARD=tl-wr841-v10
-        ;;
-    tl-wr841n-v11)
-        BOARD=tl-wr841-v11
-        grep "v12" /var/sysinfo/model && BOARD=tl-wr841-v12
-        ;;
-    nanostation-m)
-        BOARD=ubnt-nano-m
-        ;;
-    bullet-m)
-        BOARD=ubnt-bullet-m
-        grep -i "Pico" /var/sysinfo/model && BOARD=ubnt-pico-m
-        grep -i "Loco" /var/sysinfo/model && BOARD=ubnt-loco-m
-        ;;
-    unifi)
-        BOARD=ubnt-unifi
-        ;;
     loco-m-xw)
         BOARD=ubnt-loco-m-xw
         grep -i "Power" /var/sysinfo/model && BOARD=ubnt-power-m-xw
         ;;
-    unifiac-lite)
-        BOARD=ubnt-unifiac-lite
-        ;;
     tl-wa850re)
         BOARD=tl-wa850re-v1
         ;;
@@ -57,19 +20,8 @@ case "$BOARD" in
         BOARD=tl-wdr3500-v1
         ;;
     tl-wdr4300)
-        grep "3600" /var/sysinfo/model && BOARD=tl-wdr3600-v1
-        grep "4300" /var/sysinfo/model && BOARD=tl-wdr4300-v1
         grep "4310" /var/sysinfo/model && BOARD=tl-wdr4310-v1
         ;;
-    tplink,tl-wdr4900-v1)
-        BOARD=tl-wdr4900-v1
-        ;;
-    tl-mr3020)
-        BOARD=tl-mr3020-v1
-        ;;
-    archer-c7)
-        BOARD=archer-c7-v2
-        ;;
 esac
 
 uci set board.model.name=$BOARD
diff --git a/src/packages/fff/fff-network/Makefile b/src/packages/fff/fff-network/Makefile
index 0c7e2bd5..88f3bb71 100644
--- a/src/packages/fff/fff-network/Makefile
+++ b/src/packages/fff/fff-network/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=fff-network
-PKG_RELEASE:=18
+PKG_RELEASE:=19
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)
 
diff --git a/src/packages/fff/fff-network/ar71xx/network.archer-c25-v1 b/src/packages/fff/fff-network/ar71xx/network.archer-c25-v1
deleted file mode 100644
index b88b96b2..00000000
--- a/src/packages/fff/fff-network/ar71xx/network.archer-c25-v1
+++ /dev/null
@@ -1,10 +0,0 @@
-PORTORDER="4 3 2 1"
-
-WANDEV=eth0
-SWITCHDEV=eth1
-CLIENT_PORTS="1 2 0t"
-WAN_PORTS=""
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=$(cat /sys/class/net/eth1/address)
-ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.archer-c60-v1 b/src/packages/fff/fff-network/ar71xx/network.archer-c60-v1
deleted file mode 100644
index d47c93ef..00000000
--- a/src/packages/fff/fff-network/ar71xx/network.archer-c60-v1
+++ /dev/null
@@ -1,9 +0,0 @@
-PORTORDER="4 3 2 1"
-
-WANDEV=eth0
-SWITCHDEV=eth1
-CLIENT_PORTS="1 2 0t"
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=$(cat /sys/class/net/eth0/address)
-ROUTERMAC=$(cat /sys/class/net/eth1/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8
deleted file mode 100644
index ef6e2947..00000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8
+++ /dev/null
@@ -1,10 +0,0 @@
-PORTORDER="2 3 4 1"
-
-WANDEV=eth0
-SWITCHDEV=eth1
-CLIENT_PORTS="1 4 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 2 0t"
-
-ETHMESHMAC=$(cat /sys/class/net/eth0/address)
-ROUTERMAC=$(cat /sys/class/net/eth1/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr842n-v2 b/src/packages/fff/fff-network/ar71xx/network.tl-wr842n-v2
deleted file mode 100644
index 6e031316..00000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr842n-v2
+++ /dev/null
@@ -1,8 +0,0 @@
-WANDEV=eth0
-SWITCHDEV=eth1
-CLIENT_PORTS="1 4 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 2 0t"
-
-ETHMESHMAC=$(cat /sys/class/net/eth0/address)
-ROUTERMAC=$(cat /sys/class/net/eth1/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.gl-ar150 b/src/packages/fff/fff-network/ath79/network.glinet_gl-ar150
similarity index 88%
rename from src/packages/fff/fff-network/ar71xx/network.gl-ar150
rename to src/packages/fff/fff-network/ath79/network.glinet_gl-ar150
index 64049dd2..49bffebe 100644
--- a/src/packages/fff/fff-network/ar71xx/network.gl-ar150
+++ b/src/packages/fff/fff-network/ath79/network.glinet_gl-ar150
@@ -2,8 +2,8 @@
 
 PORTORDER="1"
 
-WANDEV=eth0
-SWITCHDEV=eth1
+WANDEV=eth1
+SWITCHDEV=eth0
 WAN_PORTS=
 BATMAN_PORTS="0t"
 CLIENT_PORTS="0t"
diff --git a/src/packages/fff/fff-network/ath79/network.mode b/src/packages/fff/fff-network/ath79/network.mode
new file mode 100644
index 00000000..f3a27939
--- /dev/null
+++ b/src/packages/fff/fff-network/ath79/network.mode
@@ -0,0 +1,30 @@
+################
+## This file is used to configure the behavior of network interfaces
+## if the routers interfaces differ from the standard WAN+4LAN-Ports
+## +2Wireless APs.
+## If you want to change their behavior, you should edit the file
+## /etc/network.config
+## After that you have to reboot the router with following command.
+#reboot
+#
+### The canonical syntax of this file is:
+#SPECIFIER="MODE"
+### MODES
+## Generally there are 3 operating modes for network interfaces in fff.
+#BATMAN: The interface is used to mesh with other fff-nodes
+#WAN:    The interface is used to connect to supernodes via vpn and
+#         ordinary internet.
+#CLIENT: The interface is used to connect clients to the fff-net
+##
+### SPECIFIER
+## For devices only including one ethernet port the specifier is called
+## ETHMODE. The default mode for these devices is "BATMAN".
+## For example this is the case for: gl-ar150, tl-mr3020-v1, tl-wa850re-v1,
+## tl-wa860re-v1, tl-wa901nd-v2, ubnt-bullet-m, ubnt-loco-m-xw, ubnt-nano-m,
+## ubnt-unifi
+ETHMODE="CLIENT"
+## Devices featuring 2 ethernet ports are configured by SPECIFIERs ressembling
+## the labels on the PORT itself. For the cpe210 these are called LAN0 and LAN1.
+## Therefore they are configured as follows:
+LAN0MODE="WAN"
+LAN1MODE="CLIENT"
diff --git a/src/packages/fff/fff-network/ar71xx/network.archer-c60-v2 b/src/packages/fff/fff-network/ath79/network.tplink_archer-c25-v1
similarity index 79%
rename from src/packages/fff/fff-network/ar71xx/network.archer-c60-v2
rename to src/packages/fff/fff-network/ath79/network.tplink_archer-c25-v1
index d47c93ef..59149cf7 100644
--- a/src/packages/fff/fff-network/ar71xx/network.archer-c60-v2
+++ b/src/packages/fff/fff-network/ath79/network.tplink_archer-c25-v1
@@ -1,8 +1,9 @@
 PORTORDER="4 3 2 1"
 
-WANDEV=eth0
-SWITCHDEV=eth1
+WANDEV=eth1
+SWITCHDEV=eth0
 CLIENT_PORTS="1 2 0t"
+WAN_PORTS=""
 BATMAN_PORTS="3 4 0t"
 
 ETHMESHMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v1 b/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v1
new file mode 100644
index 00000000..6d2578f6
--- /dev/null
+++ b/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v1
@@ -0,0 +1,9 @@
+PORTORDER="4 3 2 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=$(cat /sys/class/net/eth1/address)
+ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v2 b/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v2
new file mode 100644
index 00000000..6d2578f6
--- /dev/null
+++ b/src/packages/fff/fff-network/ath79/network.tplink_archer-c60-v2
@@ -0,0 +1,9 @@
+PORTORDER="4 3 2 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=$(cat /sys/class/net/eth1/address)
+ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.archer-c7-v2 b/src/packages/fff/fff-network/ath79/network.tplink_archer-c7-v2
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.archer-c7-v2
rename to src/packages/fff/fff-network/ath79/network.tplink_archer-c7-v2
diff --git a/src/packages/fff/fff-network/ar71xx/network.archer-c7-v5 b/src/packages/fff/fff-network/ath79/network.tplink_archer-c7-v5
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.archer-c7-v5
rename to src/packages/fff/fff-network/ath79/network.tplink_archer-c7-v5
diff --git a/src/packages/fff/fff-network/ar71xx/network.cpe210-v2 b/src/packages/fff/fff-network/ath79/network.tplink_cpe210-v2
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.cpe210-v2
rename to src/packages/fff/fff-network/ath79/network.tplink_cpe210-v2
diff --git a/src/packages/fff/fff-network/ar71xx/network.cpe210-v3 b/src/packages/fff/fff-network/ath79/network.tplink_cpe210-v3
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.cpe210-v3
rename to src/packages/fff/fff-network/ath79/network.tplink_cpe210-v3
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-mr3020-v1 b/src/packages/fff/fff-network/ath79/network.tplink_tl-mr3020-v1
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-mr3020-v1
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-mr3020-v1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wa901nd-v2 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wa901nd-v2
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wa901nd-v2
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wa901nd-v2
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wdr3600-v1 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wdr3600-v1
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wdr3600-v1
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wdr3600-v1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wdr4300-v1 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wdr4300-v1
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wdr4300-v1
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wdr4300-v1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v4 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043n-v5
similarity index 83%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v4
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043n-v5
index ec6d6717..c52e74e6 100644
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v4
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043n-v5
@@ -12,5 +12,5 @@ BATMAN_PORTS="3 4 0t"
 # Load second MAC address from flash because we haven't any interface with this
 # address where we can copy it from
 
-ETHMESHMAC=$(macaddr_add $(mtd_get_mac_binary product-info 8) 1)
+ETHMESHMAC=$(macaddr_add $(mtd_get_mac_binary info 8) 1)
 ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v1 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v1
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v1
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v2 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v2
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v2
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v2
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v3 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v3
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr1043nd-v3
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v3
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043n-v5 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v4
similarity index 83%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr1043n-v5
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v4
index ec6d6717..c52e74e6 100644
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr1043n-v5
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr1043nd-v4
@@ -12,5 +12,5 @@ BATMAN_PORTS="3 4 0t"
 # Load second MAC address from flash because we haven't any interface with this
 # address where we can copy it from
 
-ETHMESHMAC=$(macaddr_add $(mtd_get_mac_binary product-info 8) 1)
+ETHMESHMAC=$(macaddr_add $(mtd_get_mac_binary info 8) 1)
 ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr741nd-v4 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr740n-v4
similarity index 92%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr741nd-v4
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr740n-v4
index 334e498a..ed1a46d1 100644
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr741nd-v4
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr740n-v4
@@ -1,5 +1,4 @@
 WANDEV=eth1
-# WANDEV=eth0
 SWITCHDEV=eth0
 CLIENT_PORTS="1 4 0t"
 WAN_PORTS=
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr740n-v4 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr741nd-v4
similarity index 92%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr740n-v4
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr741nd-v4
index 334e498a..ed1a46d1 100644
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr740n-v4
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr741nd-v4
@@ -1,5 +1,4 @@
 WANDEV=eth1
-# WANDEV=eth0
 SWITCHDEV=eth0
 CLIENT_PORTS="1 4 0t"
 WAN_PORTS=
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v10 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v10
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr841-v10
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v10
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v11 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v11
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr841-v11
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v11
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v12 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v12
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr841-v12
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v12
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v7 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v7
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr841-v7
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v7
diff --git a/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v8 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v8
new file mode 100644
index 00000000..ace93630
--- /dev/null
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v8
@@ -0,0 +1,10 @@
+PORTORDER="2 3 4 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 4 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 2 0t"
+
+ETHMESHMAC=$(cat /sys/class/net/eth1/address)
+ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v9 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v9
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.tl-wr841-v9
rename to src/packages/fff/fff-network/ath79/network.tplink_tl-wr841-v9
diff --git a/src/packages/fff/fff-network/ath79/network.tplink_tl-wr842n-v2 b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr842n-v2
new file mode 100644
index 00000000..541fb3d3
--- /dev/null
+++ b/src/packages/fff/fff-network/ath79/network.tplink_tl-wr842n-v2
@@ -0,0 +1,8 @@
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 4 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 2 0t"
+
+ETHMESHMAC=$(cat /sys/class/net/eth1/address)
+ROUTERMAC=$(cat /sys/class/net/eth0/address)
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-bullet-m b/src/packages/fff/fff-network/ath79/network.ubnt_bullet-m
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-bullet-m
rename to src/packages/fff/fff-network/ath79/network.ubnt_bullet-m
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-loco-m b/src/packages/fff/fff-network/ath79/network.ubnt_nanostation-loco-m
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-loco-m
rename to src/packages/fff/fff-network/ath79/network.ubnt_nanostation-loco-m
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-nano-m b/src/packages/fff/fff-network/ath79/network.ubnt_nanostation-m
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-nano-m
rename to src/packages/fff/fff-network/ath79/network.ubnt_nanostation-m
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-pico-m b/src/packages/fff/fff-network/ath79/network.ubnt_picostation-m
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-pico-m
rename to src/packages/fff/fff-network/ath79/network.ubnt_picostation-m
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-unifi b/src/packages/fff/fff-network/ath79/network.ubnt_unifi
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-unifi
rename to src/packages/fff/fff-network/ath79/network.ubnt_unifi
diff --git a/src/packages/fff/fff-network/ar71xx/network.ubnt-unifiac-lite b/src/packages/fff/fff-network/ath79/network.ubnt_unifiac-mesh
similarity index 100%
rename from src/packages/fff/fff-network/ar71xx/network.ubnt-unifiac-lite
rename to src/packages/fff/fff-network/ath79/network.ubnt_unifiac-mesh
diff --git a/src/packages/fff/fff-network/mpc85xx/network.tl-wdr4900-v1 b/src/packages/fff/fff-network/mpc85xx/network.tplink_tl-wdr4900-v1
similarity index 100%
rename from src/packages/fff/fff-network/mpc85xx/network.tl-wdr4900-v1
rename to src/packages/fff/fff-network/mpc85xx/network.tplink_tl-wdr4900-v1
diff --git a/src/packages/fff/fff-wireless/Makefile b/src/packages/fff/fff-wireless/Makefile
index 02328a2b..6b459757 100644
--- a/src/packages/fff/fff-wireless/Makefile
+++ b/src/packages/fff/fff-wireless/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=fff-wireless
-PKG_RELEASE:=15
+PKG_RELEASE:=16
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)
 
diff --git a/src/packages/fff/fff-wireless/files/etc/uci-defaults/24b-config-wireless b/src/packages/fff/fff-wireless/files/etc/uci-defaults/24b-config-wireless
index d4f2267e..6bb71b51 100644
--- a/src/packages/fff/fff-wireless/files/etc/uci-defaults/24b-config-wireless
+++ b/src/packages/fff/fff-wireless/files/etc/uci-defaults/24b-config-wireless
@@ -6,20 +6,20 @@ BOARD="$(uci get board.model.name)"
 
 # antenna gain
 case "$BOARD" in
-	tl-wr1043nd-v1)
+	tplink,tl-wr1043nd-v1)
 		uci set wireless.radio0.antenna_gain=3
 		uci commit wireless
 		;;
-	ubnt-loco-m|\
+	ubnt,nanostation-loco-m|\
 	ubnt-loco-m-xw)
 		uci set wireless.radio0.antenna_gain=9
 		uci commit wireless
 		;;
-	ubnt-nano-m)
+	ubnt,nanostation-m)
 		uci set wireless.radio0.antenna_gain=11
 		uci commit wireless
 		;;
-	ubnt-pico-m)
+	ubnt,picostation-m)
 		uci set wireless.radio0.antenna_gain=12
 		uci commit wireless
 		;;
@@ -27,14 +27,12 @@ case "$BOARD" in
 		uci set wireless.radio0.antenna_gain=18
 		uci commit wireless
 		;;
-	ubnt-unifi)
+	ubnt,unifi)
 		# No support for Unifi AP Pro!
 		uci set wireless.radio0.antenna_gain=3
 		uci commit wireless
 		;;
-	ubnt-unifiac-lite)
-		# These are the values for the AC MESH.
-		# The actual AC Lite has different values
+	ubnt,unifiac-mesh)
 		uci set wireless.radio0.antenna_gain=4
 		uci set wireless.radio1.antenna_gain=3
 		uci commit wireless
